summaryrefslogtreecommitdiffstats
path: root/development/unicorn
diff options
context:
space:
mode:
author pyllyukko2022-12-22 17:06:39 +0100
committer Willy Sudiarto Raharjo2022-12-22 17:06:39 +0100
commitfb0938fca1b827e8a5806d0e268770041397a562 (patch)
tree4c975ab0a632a53b04064dd5e4d91f94c531f119 /development/unicorn
parentd55821710192dd8d155b36125833b120c5516624 (diff)
downloadslackbuilds-fb0938fca1b827e8a5806d0e268770041397a562.tar.gz
development/unicorn: Added (CPU Emulator Framework).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'development/unicorn')
-rw-r--r--development/unicorn/README14
-rw-r--r--development/unicorn/slack-desc19
-rw-r--r--development/unicorn/unicorn.SlackBuild107
-rw-r--r--development/unicorn/unicorn.info10
4 files changed, 150 insertions, 0 deletions
diff --git a/development/unicorn/README b/development/unicorn/README
new file mode 100644
index 0000000000..811082b62a
--- /dev/null
+++ b/development/unicorn/README
@@ -0,0 +1,14 @@
+Unicorn is a lightweight, multi-platform, multi-architecture CPU
+emulator framework, based on QEMU.
+
+Unicorn offers some unparalleled features:
+
+- Multi-architecture: ARM, ARM64 (ARMv8), M68K, MIPS, PowerPC, RISCV,
+ SPARC, S390X, TriCore and X86 (16, 32, 64-bit)
+- Clean/simple/lightweight/intuitive architecture-neutral API
+- Implemented in pure C language, with bindings for Crystal, Clojure,
+ Visual Basic, Perl, Rust, Ruby, Python, Java, .NET, Go, Delphi/Free
+ Pascal, Haskell, Pharo, and Lua.
+- High performance via Just-In-Time compilation
+- Support for fine-grained instrumentation at various levels
+- Thread-safety by design
diff --git a/development/unicorn/slack-desc b/development/unicorn/slack-desc
new file mode 100644
index 0000000000..49343a4aca
--- /dev/null
+++ b/development/unicorn/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+unicorn: unicorn (CPU emulator framework)
+unicorn:
+unicorn: Unicorn is a lightweight multi-platform, multi-architecture CPU
+unicorn: emulator framework.
+unicorn:
+unicorn:
+unicorn:
+unicorn:
+unicorn:
+unicorn: Homepage: https://www.unicorn-engine.org/
+unicorn:
diff --git a/development/unicorn/unicorn.SlackBuild b/development/unicorn/unicorn.SlackBuild
new file mode 100644
index 0000000000..e4a52187fe
--- /dev/null
+++ b/development/unicorn/unicorn.SlackBuild
@@ -0,0 +1,107 @@
+#!/bin/bash
+
+# Slackware build script for Unicorn
+
+# Copyright 2022 pyllyukko
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=unicorn
+VERSION=${VERSION:-2.0.1}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir -p build
+cd build
+ cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+ -DMAN_INSTALL_DIR=/usr/man \
+ -DCMAKE_BUILD_TYPE=Release ..
+ make
+ make install/strip DESTDIR=$PKG
+cd ..
+
+rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ TODO SECURITY.md README.md ChangeLog CREDITS.TXT COPYING_GLIB COPYING.LGPL2 COPYING AUTHORS.TXT \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/development/unicorn/unicorn.info b/development/unicorn/unicorn.info
new file mode 100644
index 0000000000..e2c90e1c2e
--- /dev/null
+++ b/development/unicorn/unicorn.info
@@ -0,0 +1,10 @@
+PRGNAM="unicorn"
+VERSION="2.0.1"
+HOMEPAGE="https://www.unicorn-engine.org/"
+DOWNLOAD="https://github.com/unicorn-engine/unicorn/archive/2.0.1/unicorn-2.0.1.tar.gz"
+MD5SUM="85b09e91cec6034f7169772c050ceb0d"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="pyllyukko"
+EMAIL="pyllyukko@maimed.org"